using Microsoft.UI.Xaml;
using Microsoft.UI.Xaml.Controls;

namespace TestProject
{
    /// <summary>
    ///  
    /// </summary>
    public sealed partial class MainPage : Page
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - MainPage()

        /// <summary>
        /// 
        /// </summary>
        public MainPage()
        {
            InitializeComponent();

            this.tabView.Loaded            += tabView_Loaded;
            this.tabView.AddTabButtonClick += tabView_AddButtonClick;
            this.tabView.TabCloseRequested += tabView_TabCloseRequested;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region   ε óϱ - tabView_Loaded(sender, e)

        /// <summary>
        ///   ε óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void tabView_Loaded(object sender, RoutedEventArgs e)
        {
            for(int i = 0; i < 3; i++)
            {
                (sender as TabView).TabItems.Add(CreateNewTab(i));
            }
        }

        #endregion
        #region   ߰ ư Ŭ óϱ - tabView_AddButtonClick(sender, e)

        /// <summary>
        ///   ߰ ư Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void tabView_AddButtonClick(TabView sender, object e)
        {
            sender.TabItems.Add(CreateNewTab(sender.TabItems.Count));
        }

        #endregion
        #region    ݱ û óϱ - tabView_TabCloseRequested(sender, e)

        /// <summary>
        ///    ݱ û óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void tabView_TabCloseRequested(TabView sender, TabViewTabCloseRequestedEventArgs e)
        {
            sender.TabItems.Remove(e.Tab);
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Function

        #region   ϱ - CreateNewTab(index)

        /// <summary>
        ///   ϱ
        /// </summary>
        /// <param name="index">ε</param>
        /// <returns> </returns>
        private TabViewItem CreateNewTab(int index)
        {
            TabViewItem newItem = new TabViewItem
            {
                Header     = $"Document {index}",
                IconSource = new SymbolIconSource() { Symbol = Symbol.Document }
            };

            switch(index % 3)
            {
                case 0 : newItem.Content = new SamplePage1(); break;
                case 1 : newItem.Content = new SamplePage2(); break;
                case 2 : newItem.Content = new SamplePage3(); break;
            }

            return newItem;
        }

        #endregion
    }
}